import java.io.*;
// import antlr.debug.misc.*;

class Main {
    public static void main(String[] args) {
	try {
	    FileInputStream filename = new FileInputStream(args[0]);
	    DataInputStream input = new DataInputStream(filename);
	    MyLexer lexer = new MyLexer(new DataInputStream(input));
	    MyParser parser = new MyParser(lexer);
	    parser.program();
	    antlr.CommonAST ast = (antlr.CommonAST) parser.getAST();
	    // ASTFrame frame = new ASTFrame("AST", ast);
	    // frame.setVisible(true);
	    MyWalker walker = new MyWalker();
	    Stmt s = walker.program(ast);
	    int begin = s.newlabel();
	    int after = s.newlabel();
	    s.emitlabel(begin);
	    s.gen(begin, after);
	    s.emitlabel(after);
	    System.out.println("");
	} catch (Exception e) {
	    System.err.println("exception: " + e);
	}	
    }
}
